



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>TIME_WAIT</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">TIME_WAIT</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 06:19:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>前言</h3>
<p>请说说你对TCP连接中time_wait状态的理解</p>
<h3>解答：</h3>
<p>先上TCP的状态变迁图</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170823193112679?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvdTAxMzYxNjk0NQ==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p><strong>1. time_wait状态如何产生？</strong>&nbsp;<br />由上面的变迁图，首先调用close()发起主动关闭的一方，在发送最后一个ACK之后会进入time_wait的状态，也就说该发送方会保持2MSL时间之后才会回到初始状态。MSL值得是数据包在网络中的最大生存时间。产生这种结果使得这个TCP连接在2MSL连接等待期间，定义这个连接的四元组（客户端IP地址和端口，服务端IP地址和端口号）不能被使用。</p>
<p><strong>2.time_wait状态产生的原因</strong></p>
<p><strong>1）为实现TCP全双工连接的可靠释放</strong></p>
<p>由TCP状态变迁图可知，假设发起主动关闭的一方（client）最后发送的ACK在网络中丢失，由于TCP协议的重传机制，执行被动关闭的一方（server）将会重发其FIN，在该FIN到达client之前，client必须维护这条连接状态，也就说这条TCP连接所对应的资源（client方的local_ip,local_port）不能被立即释放或重新分配，直到另一方重发的FIN达到之后，client重发ACK后，经过2MSL时间周期没有再收到另一方的FIN之后，该TCP连接才能恢复初始的CLOSED状态。如果主动关闭一方不维护这样一个TIME_WAIT状态，那么当被动关闭一方重发的FIN到达时，主动关闭一方的TCP传输层会用RST包响应对方，这会被对方认为是有错误发生，然而这事实上只是正常的关闭连接过程，并非异常。</p>
<p><strong>2）为使旧的数据包在网络因过期而消失</strong></p>
<p>为说明这个问题，我们先假设TCP协议中不存在TIME_WAIT状态的限制，再假设当前有一条TCP连接：(local_ip, local_port, remote_ip,remote_port)，因某些原因，我们先关闭，接着很快以相同的四元组建立一条新连接。本文前面介绍过，TCP连接由四元组唯一标识，因此，在我们假设的情况中，TCP协议栈是无法区分前后两条TCP连接的不同的，在它看来，这根本就是同一条连接，中间先释放再建立的过程对其来说是&ldquo;感知&rdquo;不到的。这样就可能发生这样的情况：前一条TCP连接由local peer发送的数据到达remote peer后，会被该remot peer的TCP传输层当做当前TCP连接的正常数据接收并向上传递至应用层（而事实上，在我们假设的场景下，这些旧数据到达remote peer前，旧连接已断开且一条由相同四元组构成的新TCP连接已建立，因此，这些旧数据是不应该被向上传递至应用层的），从而引起数据错乱进而导致各种无法预知的诡异现象。作为一种可靠的传输协议，TCP必须在协议层面考虑并避免这种情况的发生，这正是TIME_WAIT状态存在的第2个原因。</p>
<p><strong>3）总结</strong>&nbsp;<br />具体而言，local peer主动调用close后，此时的TCP连接进入TIME_WAIT状态，处于该状态下的TCP连接不能立即以同样的四元组建立新连接，即发起active close的那方占用的local port在TIME_WAIT期间不能再被重新分配。由于TIME_WAIT状态持续时间为2MSL，这样保证了旧TCP连接双工链路中的旧数据包均因过期（超过MSL）而消失，此后，就可以用相同的四元组建立一条新连接而不会发生前后两次连接数据错乱的情况。</p>
<p><strong>3.time_wait状态如何避免</strong></p>
<p>首先服务器可以设置SO_REUSEADDR套接字选项来通知内核，如果端口忙，但TCP连接位于TIME_WAIT状态时可以重用端口。在一个非常有用的场景就是，如果你的服务器程序停止后想立即重启，而新的套接字依旧希望使用同一端口，此时SO_REUSEADDR选项就可以避免TIME_WAIT状态。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k3o5qj.html">IntelliJ IDEA使用（一）：创建maven web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93xl2g9.html">format not a string literal and no format arguments</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jm0e09.html">【转】微信小程序给程序员带来的可能是一个赚钱的机遇</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdoywx8.html">第三章：Git使用入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96ev5vq.html">How to change statusbar text color to dark on android 4&period;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pzexk8.html">struts2中各种值栈问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ro3m79.html">EF架构~为EF DbContext生成的实体添加注释（T5模板应用）（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkx4j8.html">时间作为横轴的图表（morris&period;js）超越昨天的自己系列（8）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oygjy9.html">TopCoder SRM 633div1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1evkn9.html">POJ1850&mdash;&mdash;Code&lpar;组合数学&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj120z9.html">Core第三方开源Web框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepgl78.html">linux 发送带附件的邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgy6le8.html">adb报错：The connection to adb is down&comma; and a severe&amp;amp&semi;nbs</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zormnvq.html">HUST 1584 摆放餐桌</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj35e1q.html">原创：LNMP架构部署个人博客网站  禁止转载复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd4kkk9.html">java中的数组二分法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yzy6n8.html">Android 最简单的测试UI卡顿</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyv5lx9.html">《神经网络算法与实现-基于Java语言》的读书笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506xv68.html">安装软件the error code is 2203解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypk5z9.html">java基础语法&lpar;三大基础&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdwged9.html">EChart&period;js 简单入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rmxy58.html">js实现原生选项卡</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv25m2z9.html">怎么在多场景下使用不同的 git 账号 commit</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj1vo49.html">软件151  王楚博  struts</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rm3e68.html">perceptual loss</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwnl478.html">linux 普通用户批量创建账户与密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyywm0jq.html">java8 stream lambda  一个例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvm76g8.html">volatile 与 JVM 指令重排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv256gx9.html">MySQL data sync to Oracle with OGG&lpar;Remote Delivery&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gr5emq.html">Fiddle手机抓包</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
